<?php
/**
 * ARRA User Export Import component for Joomla! 1.5
 * @version 1.0.0
 * @author ARRA (joomlarra@gmail.com)
 * @link http://www.joomlarra.com
 * @Copyright (C) 2010 joomlarra.com. All Rights Reserved.
 * @license GNU General Public License version 2 or later; see LICENSE.txt
 *
    *ARRA User Export is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by
    *the Free Software Foundation, either version 3 of the License, or(at your option) any later version.
    *This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    *GNU General Public License for more details.
    *You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * file: view.html.php
 *
 **** class 
     ArrausersexportimportViewAdditionalcolumns 
	 
 **** functions
     display();
	 uploadSqlZipFile();
	 uploadCsvTxtFile();
	 allSettings();
	 emailSettings();
	 setDefaultUsertype();
	 checked();
	 errorMessage();
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.view' );
JHTML::_( 'behavior.modal' );

/**
 * ArrausersexportimportViewImport View
 *
 */
class ArrausersexportimportViewAdditionalcolumns extends JView{
	/**
	 * display method 
	 * @return void
	 **/
	function display($tpl = null){						
		
		// make ToolBarHelper with name of component.
		JToolBarHelper::custom('import_button', 'import.png', 'import.png', 'Import', false, false);
		JToolBarHelper::cancel ('cancel', 'Cancel');
		JToolBarHelper::title(   JText::_( 'ARRA_USER_EXPORT' ), 'generic.png' );				
		
		$additional_columns = $this->additionalColumns();
		$this->assignRef('additional_columns', $additional_columns);
				
		$upload_file_csv_txt = $this->uploadCsvTxtFile();		
		$this->assignRef('upload_file_csv_txt', $upload_file_csv_txt);
			
		$allSettings = $this->allSettings();		
		$this->assignRef('allSettings', $allSettings);
		
		$emailSettings = $this->emailSettings();		
		$this->assignRef('emailSettings', $emailSettings);
				
		$error_message = $this->errorMessage();
		$this->assignRef('error_message', $error_message);
				
		parent::display($tpl);
	}
	
	function additionalColumns(){
		$number = 35;
		$return  = "";
		$return .= "<table width=\"100%\">";
		$return .= 	  "<tr>";
		$return .= 	  	  "<td class=\"td_settings_options\" width=\"80%\">";
		$return .= 	  	  		"<span class=\"editlinktip hasTip\" title=\"Additional Columns::".JText::_("ARRA_TIP_ADDITIONAL_COLUMNS_DETAILS") ."\" >".
											JText::_("ARRA_ADDITIONAL_COLUMNS_DETAILS");
		$return .= 	  	  		"</span>";
		$return .= 	  	  "</td>";
		$return .= 	  	  "<td align=\"center\">";
		$return .= 	  	  	'<select name="number_columns" onchange="javascript:setAdditionalColumn(this);">';
		for($i=0; $i<=$number; $i++){
			$return .= 	  	  	'<option>'.$i.'</option>';
		}
		$return .= 	  	  	'</select';
		$return .= 	  	  "</td>";		
		$return .= 	  "</tr>";
		$return .= 	  "<tr>";
		$return .= 	      "<td colspan=\"2\" align=\"center\">";
		$return .= 	  	  	'<table>';
		for($i=0; $i<35; $i++){			
			$return .= 	  	 '<tr>';
			$return .= 	  	  	'<td>';
			$return .= 	  	  		'<div id="column'.($i+1).'" style="display:none; background-color:#F6F6F6; border-bottom:1px solid #E9E9E9; border-right:1px solid #E9E9E9; color:#666666; font-weight:bold; padding:5px;">';
			$return .= 	  	  		"<span class=\"editlinktip hasTip\" title=\"Additional Columns::".JText::_("ARRA_TIP_COLUMNS_DETAILS") ."\" >".JText::_("ARRA_COLUMN")." ".($i+1)."</span> &nbsp;".'<input type="text" name="column'.($i+1).'" />&nbsp;&nbsp;&nbsp; <span class="editlinktip hasTip" title="Additional Columns::'.JText::_("ARRA_TIP_DEFAULT_VALUE_DETAILS").'" >'.JText::_("ARRA_COLUMN_DEFAULT_VALUE")."</span>&nbsp;".'<input type="text" name="default_value'.($i+1).'" />';
			$return .= 	  	  		'<div>';
			$return .= 	  	  	'</td>';
			$return .= 	  	 '</tr>';
		}
		$return .= 	  	  	'</table>';
		$return .= 	      "</td>";
		$return .= 	  "</tr>";
		$return .= "</table>";
		return $return;
	}
	
	function errorMessage(){
		
		$same_user = 0;
		$empty_column = 0;
		
		if(isset($_SESSION['link_eror']) && $_SESSION['link_eror']=="error"){
			$same_user = 1;
		}
		if(isset($_SESSION['error_empty_column']) && $_SESSION['error_empty_column']=="error_empty_column"){
			$empty_column = 1;
		}		
		$error  = "";
		$error .= "<table>";
		if($same_user == 1 && $empty_column == 0){
			$error .=      "<tr>";
			$error .=          "<td>";
			$error .=              JText::_("ARRA_ERROR_MESSAGE_SAME_EMAIL");  
			$error .=          "</td>";
			$error .=      "</tr>";
			$error .=      "<tr>";
			$error .=          "<td>";
			$error .=             "<a href=\"".Juri::base()."components/com_arrauserexportimport/files/error_same_email.csv"."\" target=\"_blank\">error_same_email.csv</a>";      
			$error .=          "</td>";
			$error .=      "</tr>";
		}
		elseif($same_user == 0 && $empty_column == 1){
			$error .=      "<tr>";
			$error .=          "<td>";
			$error .=              JText::_("ARRA_NOTE_MESSAGE_EMPTY_COLUMN");  
			$error .=          "</td>";
			$error .=      "</tr>";
			$error .=      "<tr>";
			$error .=          "<td>";
			$error .=             "<a href=\"".Juri::base()."components/com_arrauserexportimport/files/error_empty_column.csv"."\" target=\"_blank\">error_empty_column.csv</a>";
			$error .=          "</td>";
			$error .=      "</tr>";
		}
		elseif($same_user == 1 && $empty_column == 1){
			$error .=      "<tr>";
			$error .=          "<td>";
			$error .=              JText::_("ARRA_ERROR_MESSAGE_SAME_EMAIL");  
			$error .=          "</td>";
			$error .=      "</tr>";
			$error .=      "<tr>";
			$error .=          "<td>";
			$error .=             "<a href=\"".Juri::base()."components/com_arrauserexportimport/files/error_same_email.csv"."\" target=\"_blank\">error_same_email.csv</a>";      
			$error .=          "</td>";
			$error .=      "</tr>";
			$error .=      "<tr>";
			$error .=          "<td>";
			$error .=              JText::_("ARRA_NOTE_MESSAGE_EMPTY_COLUMN");  
			$error .=          "</td>";
			$error .=      "</tr>";			
			$error .=          "<td>";
			$error .=             "<a href=\"".Juri::base()."components/com_arrauserexportimport/files/error_empty_column.csv"."\" target=\"_blank\">error_empty_column.csv</a>";
			$error .=          "</td>";
			$error .=      "</tr>";
		}
		$error .= "</table>";		
		return $error;
	}
	
	function emailSettings(){
	
		$db =& JFactory::getDBO();
	    $sql= "select params from #__components where link='option=com_arrauserexportimport'";
	    $db->setQuery($sql);
	    $all_result = $db->loadResult();
		$result = "";
		$settings_saved = false;	  
		
	    if(strlen($all_result) != 0){
		    $all_array = unserialize($all_result);				    				
			if(isset($all_array["AdditionalColumns"]) && strlen(trim($all_array["AdditionalColumns"])) != 0){								
			   $result = $all_array["AdditionalColumns"];			
		       $settings_saved = true;  
			}
			else{
			   $settings_saved = false;  
			}		
		}
	
		$defaul_email_template  = "";
		$defaul_email_template .= "Congratulations, you have been registered as a user on {sitename}.\n\n";
		$defaul_email_template .= "Below are your login credentials: \n\n";		
		$defaul_email_template .= "name: {name}\n";
		$defaul_email_template .= "username: {username}\n";
		$defaul_email_template .= "usertype: {usertype}\n";
		$defaul_email_template .= "password: {password}\n";
		
		$default_subject_template  = "";
		$default_subject_template .= "Account details for {username} from {sitename}";
		
	    $config = new JConfig();
	    $emailSettings = "";
		
		$emailSettings .= "<table width=\"100%\" cellspacing=\"5\">";
		$emailSettings .=     "<tr>";
		$emailSettings .=        "<td width=\"55%\" valign=\"top\">";
				
		$emailSettings .= "<table>";
		$emailSettings .=     "<tr>";
		$emailSettings .=         "<td colspan=\"2\"  class=\"td_settings_2\">";
		$emailSettings .=             "<span><a style=\"color:red;\" href=\"#\" onclick=\"javascript:hide_show('email_div'); return false;\">".JText::_("ARRA_EMAILS_TO_NEW_USERS_2_HEADER")."</a></span>".
							   			"<div id=\"email_div\" style=\"display:none; color:red;\">".JText::_("ARRA_EMAILS_TO_NEW_USERS_2")."</div><br/>";
		$emailSettings .=             "<input type=\"checkbox\" name=\"send_email_to_import\" id=\"send_email_to_import\" checked>" . "&nbsp;&nbsp;" . JText::_("ARRA_EMAILS_TO_NEW_USERS");
		$emailSettings .=         "</td>";
		$emailSettings .=     "</tr>"; 	
		
		$emailSettings .=     "<tr>";
		$emailSettings .=         "<td  class=\"td_settings_options\">";
		$emailSettings .=              "<span class=\"editlinktip hasTip\" title=\"Subject::".JText::_("ARRA_TIP_SUBJECT") ."\" >".
											JText::_("ARRA_EMAIL_IMPORT_SUBJECT").
									   "</span>";
		$emailSettings .=         "</td>";
		$emailSettings .=         "<td class=\"td_settings\">";
		$emailSettings .=             "<textarea rows=\"1\" cols=\"50\" name=\"subject_template\" onkeyup=\"this.style.border='1px solid silver'\"  id=\"subject_template\">";
		if($settings_saved == true){
			$emailSettings .=				 $this->checked("subject_template",$result);
		}
		else{
			$emailSettings .=				 $default_subject_template;
		}
        $emailSettings .=             "</textarea>";
		$emailSettings .=         "</td>";
		$emailSettings .=     "</tr>";
			
		$emailSettings .=     "<tr>";
		$emailSettings .=         "<td class=\"td_settings_options\">";
		$emailSettings .=              "<span class=\"editlinktip hasTip\" title=\"{from_email}::".JText::_("ARRA_TIP_FROM_EMAIL") ."\" >".
											"{from_email}" .
									   "</span>";
		$emailSettings .=         "</td>";
		$emailSettings .=         "<td class=\"td_settings\">";
		$emailSettings .=             "<input type=\"text\" name=\"from_email\" onkeyup=\"this.style.border='1px solid silver'\" value=\"";
		
		if($settings_saved == true){
			$emailSettings .=				 $this->checked("from_email",$result);
		}
		else{
			$emailSettings .=				 $config->mailfrom;
		}
		
		$emailSettings .=         "\" id=\"from_email\" size=\"40\">";
		$emailSettings .=         "</td>";
		$emailSettings .=     "</tr>";		
		$emailSettings .=     "<tr>";
		$emailSettings .=         "<td class=\"td_settings_options\">";
		$emailSettings .=              "<span class=\"editlinktip hasTip\" title=\"{from_name}::".JText::_("ARRA_TIP_FROM_NAME") ."\" >".
											"{from_name}" .
									   "</span>";
		$emailSettings .=         "</td>";
		$emailSettings .=         "<td class=\"td_settings\">";
		$emailSettings .=             "<input type=\"text\" name=\"from_name\" value=\"";
		
		if($settings_saved == true){
			$emailSettings .=				 $this->checked("from_name",$result);
		}
		else{
			$emailSettings .=				 $config->fromname;
		}
		
		$emailSettings .=         "\" onkeyup=\"this.style.border='1px solid silver'\"  id=\"from_name\"  size=\"40\">";				
		$emailSettings .=         "</td>";
		$emailSettings .=     "</tr>";		
		$emailSettings .=     "<tr>";
		$emailSettings .=         "<td class=\"td_settings_options\">";
		$emailSettings .=              "<span class=\"editlinktip hasTip\" title=\"{sitename}::".JText::_("ARRA_TIP_SITE_NAME") ."\" >".
											"{sitename}" .
									   "</span>";
		$emailSettings .=         "</td>";
		$emailSettings .=         "<td class=\"td_settings\">";
		$emailSettings .=             "<input type=\"text\" name=\"sitename\" value=\"";
		
		if($settings_saved == true){
			$emailSettings .=				 $this->checked("sitename",$result);
		}
		else{
			$emailSettings .=				 $config->sitename;
		}
		
		$emailSettings .= 		"\" onkeyup=\"this.style.border='1px solid silver'\"  id=\"sitename\"  size=\"40\">";       
		$emailSettings .=         "</td>";
		$emailSettings .=     "</tr>";		
		$emailSettings .=     "<tr>";
		$emailSettings .=         "<td class=\"td_settings_2\">";
		$emailSettings .=             "{username}";
		$emailSettings .=         "</td>";
		$emailSettings .=         "<td class=\"td_settings_2\">";
		$emailSettings .=              JText::_("ARRA_EMAILS_USERNAME"); 
		$emailSettings .=         "</td>";
		$emailSettings .=     "</tr>";		
		$emailSettings .=     "<tr>";
		$emailSettings .=         "<td class=\"td_settings_2\">";
		$emailSettings .=             "{name}";
		$emailSettings .=         "</td>";
		$emailSettings .=         "<td class=\"td_settings_2\">";
		$emailSettings .=              JText::_("ARRA_EMAILS_NAME"); 
		$emailSettings .=         "</td>";
		$emailSettings .=     "</tr>";
		$emailSettings .=     "<tr>";
		$emailSettings .=         "<td class=\"td_settings_2\">";
		$emailSettings .=             "{email}";
		$emailSettings .=         "</td>";
		$emailSettings .=         "<td class=\"td_settings_2\">";
		$emailSettings .=              JText::_("ARRA_EMAILS_EMAIL"); 
		$emailSettings .=         "</td>";
		$emailSettings .=     "</tr>";		
		$emailSettings .=     "<tr>";
		$emailSettings .=         "<td class=\"td_settings_2\">";
		$emailSettings .=             "{usertype}";
		$emailSettings .=         "</td>";
		$emailSettings .=         "<td class=\"td_settings_2\">";
		$emailSettings .=              JText::_("ARRA_EMAILS_USERTYPE"); 
		$emailSettings .=         "</td>";
		$emailSettings .=     "</tr>";		
		$emailSettings .=     "<tr>";
		$emailSettings .=         "<td class=\"td_settings_2\">";
		$emailSettings .=             "{password}";
		$emailSettings .=         "</td>";
		$emailSettings .=         "<td class=\"td_settings_2\">";
		$emailSettings .=              JText::_("ARRA_EMAILS_PASSWORD"); 
		$emailSettings .=         "</td>";
		$emailSettings .=     "</tr>";			
		$emailSettings .= "</table>";		
		$emailSettings .=       "</td>";		
		$emailSettings .=       "<td valign=\"top\" align=\"center\">";
		$emailSettings .=          "<table>";		
		$emailSettings .=              "<tr>";
		$emailSettings .=                 "<td class=\"td_settings_2\">";
		$emailSettings .=                     JText::_("ARRA_IMPORT_BODY_EMAIL");
		$emailSettings .=                 "</td>";
		$emailSettings .=              "</tr>";		
		$emailSettings .=              "<tr>";
		$emailSettings .=                 "<td>";
		$emailSettings .=                     "<textarea rows=\"16\" cols=\"50\" name=\"email_template\" onkeyup=\"this.style.border='1px solid silver'\"  id=\"email_template\">";
		
		if($settings_saved == true){
			$emailSettings .=				 $this->checked("email_template",$result);
		}
		else{
			$emailSettings .=				 $defaul_email_template;
		}
		
        $emailSettings .=                     "</textarea>";
		$emailSettings .=                 "</td>";
		$emailSettings .=              "</tr>";
		$emailSettings .=          "</table>";  
		$emailSettings .=       "</td>";		 
		$emailSettings .=    "</tr>";
		$emailSettings .=    "<tr>";		
		$emailSettings .=       "<td class=\"td_settings_2\">&nbsp;&nbsp;";
		$emailSettings .=           JText::_("ARRA_EMAIL_TEMPLATE_NOTE");
		$emailSettings .=       "</td>";		
		$emailSettings .=    "</tr>";
		$emailSettings .= "</table>";
		
		return $emailSettings;
	}
	
	function uploadCsvTxtFile(){
	    $upload_file = "";
		$upload_file .= "<table>";
		$upload_file .= 		"<tr>";
		$upload_file .= 			"<td width=\"25%\">";		   
		$upload_file .= 				"<input name=\"csvtxt_file_upload\" type=\"FILE\" id=\"csvtxt_file_upload\" size=\"50px\" onclick=\"document.getElementById('sqlzip_file_upload').value='';\">";				  			  
		$upload_file .= 			"</td>"; 
		$upload_file .= 			"<td align=\"left\"  width=\"75%\">";
		$upload_file .= 				"<input type=\"submit\" name=\"import_button\" value=\"Import\" onClick=\"document.adminForm.file_import.value='csv_txt'; return validateImportForm();\">";	
		$upload_file .= 			"</td>";
		$upload_file .= 		"</tr>";
		$upload_file .= 		"<tr>";		
		$upload_file .= 			"<td class=\"td_settings_options\" colspan=\"2\">";
		$upload_file .= "<div class=\"space\"></div>";
		$upload_file .=                 JText::_("ARRA_DOWNLOAD_EXAMPLE");
		$upload_file .= "<div class=\"space\"></div>";
		$upload_file .= 			    JText::_("ARRA_IMPORT_TXT_EXAMPLE")."&nbsp;&nbsp;&nbsp;&nbsp;"."<a href=\"".Juri::base()."components/com_arrauserexportimport/files/txt_example.txt"."\" target=\"_blank\"> example.txt</a>"; 
		$upload_file .= "<br/>";
		$upload_file .= 			    JText::_("ARRA_IMPORT_CSV_EXAMPLE")."&nbsp;&nbsp;"."<a href=\"".Juri::base()."components/com_arrauserexportimport/files/csv_example.csv"."\"> example.csv</a>"; 
		$upload_file .= 			"</td>";
		$upload_file .= 		"</tr>";
		$upload_file .= 		"<tr>";
		$upload_file .= 		   "<td>";
		$upload_file .= 		       "<a rel=\"{handler: 'iframe', size: {x: 500, y: 315}}\"  class=\"modal\"  href=\"index.php?option=com_arrauserexportimport&controller=modal&task=modal&tmpl=component\">".JText::_('VIEWPACKAGE_ALL_COLUMNS_BUTTON')."</a>";
		$upload_file .= 		   "</td>";
		$upload_file .= 		"</tr>";
		$upload_file .= "</table>";
		
		return $upload_file; 
	}	
	
	function allSettings(){
		$settings_saved = false;    	  
	    $db =& JFactory::getDBO();
	    $sql= "select params from #__components where link='option=com_arrauserexportimport'";
	    $db->setQuery($sql);
	    $all_result = $db->loadResult();
		$result = "";	  
		
	    if(strlen($all_result) != 0){
		    $all_array = unserialize($all_result);				    				
			if(isset($all_array["AdditionalColumns"]) && strlen(trim($all_array["AdditionalColumns"])) != 0){								
			   $result = $all_array["AdditionalColumns"];			
		       $settings_saved = true;  
			}
			else{
			   $settings_saved = false;  
			}		
		}
	
	    $allSettings = "";
		$allSettings .= "<table cellspacing=\"5\">";
		$allSettings .=     "<tr>";
		$allSettings .=         "<td class=\"td_settings_options\">";
		$allSettings .=        "<span class=\"editlinktip hasTip\" title=\"" . JText::_("ARRA_SEPARATOR")."::".JText::_("ARRA_TIP_SEPARATOR") ."\" >".
					                JText::_("ARRA_SEPARATOR")."<br/>".
						       "</span>";
		$allSettings .=        "<span><a style=\"color:red;\" href=\"#\" onclick=\"javascript:hide_show('separator_div'); return false;\">".JText::_("ARRA_SEPARATOR_2_HEADER")."</a></span><div id=\"separator_div\" style=\"display:none; color:red;\">".JText::_("ARRA_SEPARATOR_22")."</div>";					   
		$allSettings .=         "</td>";
		$allSettings .=        "<td class=\"td_settings\" valign=\"top\">";
		$allSettings .=             "<select name=\"separator\">";		
		$select = "";
		if($this->checked("separator", $result)== ","){
			$select = ' selected="selected" ';
		}
		$allSettings .=     			"<option value=\",\" ".$select."> , " .JText::_("ARRA_COMMA") . "</option>";
		$select = "";
		if($this->checked("separator", $result) == ";" || $this->checked("separator", $result) == ""){
			$select = ' selected="selected" ';
		}
		$allSettings .=    				"<option value=\";\" ".$select."> ; " . JText::_("ARRA_SEMICOLON") . "</option>";
		$select = "";
		if($this->checked("separator", $result) == "|"){			
			$select = ' selected="selected" ';
		}
		$allSettings .= 				"<option value=\"|\" ".$select."> | " . JText::_("ARRA_VERTICAL_BAR") . "</option>";
		$select = "";
		if($this->checked("separator", $result)== "."){
			$select = ' selected="selected" ';
		}
		$allSettings .= 				"<option value=\".\" ".$select."> . " . JText::_("ARRA_DOT") . "</option>";
		$select = "";			 
		$allSettings .= 			"</select>";
		$allSettings .=        "</td>";
		$allSettings .=     "</tr>";		
		$allSettings .=     "<tr>";
		$allSettings .=         "<td class=\"td_settings_options\">"; 
		$allSettings .=        "<span class=\"editlinktip hasTip\" title=\"" . JText::_("ARRA_OVERWRITE_ALL_TO_EXISTING_USER")."::".JText::_("ARRA_TIP_OWRITE_ALL") ."\" >".
					                JText::_("ARRA_OVERWRITE_ALL_TO_EXISTING_USER") .
						       "</span>";
		$allSettings .=         "</td>";
		$allSettings .=         "<td class=\"td_settings\">";
		$allSettings .=             "<input type=\"checkbox\" name=\"same_user_option_checkbox\" value=\"change_all\"> "; 
		$allSettings .=         "</td>";		
		$allSettings .=     "</tr>";
		$allSettings .=     "<tr>";
		$allSettings .=         "<td class=\"td_settings_options\">";
		$allSettings .=        "<span class=\"editlinktip hasTip\" title=\"" . JText::_("ARRA_OVERWRITE_USERTYPE_TO_EXISTING_USER")."::".JText::_("ARRA_TIP_OWRITE_USERTYPE") ."\" >".
					                 JText::_("ARRA_OVERWRITE_USERTYPE_TO_EXISTING_USER") .
						       "</span>";
		$allSettings .=         "</td>";
		$allSettings .=         "<td class=\"td_settings\">";
		if($settings_saved == false){
			$allSettings .=           JText::_("ARRA_YES") . "<input type=\"radio\" name=\"same_user_option_radio_usertype\" value=\"0\"> ";
			$allSettings .=           JText::_("ARRA_NO") . "<input type=\"radio\" name=\"same_user_option_radio_usertype\" value=\"1\" checked> ";
		}
		else{
		    if($this->checked("same_user_option_radio_usertype",$result)==0){
			   $allSettings .=        JText::_("ARRA_YES") . "<input type=\"radio\" name=\"same_user_option_radio_usertype\" value=\"0\" checked> ";
			   $allSettings .=        JText::_("ARRA_NO") . "<input type=\"radio\" name=\"same_user_option_radio_usertype\" value=\"1\"> ";
			}
			else{
			   $allSettings .=        JText::_("ARRA_YES") . "<input type=\"radio\" name=\"same_user_option_radio_usertype\" value=\"0\"> ";
			   $allSettings .=        JText::_("ARRA_NO") . "<input type=\"radio\" name=\"same_user_option_radio_usertype\" value=\"1\" checked> "; 
			}		    
		}
		$allSettings .=         "</td>";
		$allSettings .=     "</tr>";
		$allSettings .=     "<tr>";
		$allSettings .=         "<td class=\"td_settings_options\">";
		$allSettings .=        "<span class=\"editlinktip hasTip\" title=\"" . JText::_("ARRA_OVERWRITE_PASSWORD_TO_EXISTING_USER")."::".JText::_("ARRA_TIP_OWRITE_PASSWORD") ."\" >".
					                  JText::_("ARRA_OVERWRITE_PASSWORD_TO_EXISTING_USER") .
						       "</span>";
		$allSettings .=         "</td>";
		$allSettings .=         "<td class=\"td_settings\">";
		if($settings_saved == false){
			$allSettings .=           JText::_("ARRA_YES") . "<input type=\"radio\" name=\"same_user_option_radio_password\" value=\"0\"> ";
			$allSettings .=           JText::_("ARRA_NO") . "<input type=\"radio\" name=\"same_user_option_radio_password\" value=\"1\" checked> ";
		}
		else{
		    if($this->checked("same_user_option_radio_password",$result)==0){
			    $allSettings .=       JText::_("ARRA_YES") . "<input type=\"radio\" name=\"same_user_option_radio_password\" value=\"0\" checked> ";
			    $allSettings .=       JText::_("ARRA_NO") . "<input type=\"radio\" name=\"same_user_option_radio_password\" value=\"1\"> ";
			}
			else{
			    $allSettings .=       JText::_("ARRA_YES") . "<input type=\"radio\" name=\"same_user_option_radio_password\" value=\"0\"> ";
			    $allSettings .=       JText::_("ARRA_NO") . "<input type=\"radio\" name=\"same_user_option_radio_password\" value=\"1\" checked> ";
			}
		}
		$allSettings .=         "</td>";
		$allSettings .=     "</tr>";
		
		$allSettings .=     "<tr>";
		$allSettings .=         "<td class=\"td_settings_options\">";
		$allSettings .=        "<span class=\"editlinktip hasTip\" title=\"" . JText::_("ARRA_OVERWRITE_EMAIL_TO_EXISTING_USER")."::".JText::_("ARRA_TIP_OWRITE_EMAIL") ."\" >".
					                  JText::_("ARRA_OVERWRITE_EMAIL_TO_EXISTING_USER") .
						       "</span>";
		$allSettings .=         "</td>";
		$allSettings .=         "<td class=\"td_settings\">";
		if($settings_saved == false){
			$allSettings .=           JText::_("ARRA_YES") . "<input type=\"radio\" name=\"same_user_option_radio_email\" value=\"0\"> ";
			$allSettings .=           JText::_("ARRA_NO") . "<input type=\"radio\" name=\"same_user_option_radio_email\" value=\"1\" checked> ";
		}
		else{
		    if($this->checked("same_user_option_radio_email",$result)==0){
			     $allSettings .=      JText::_("ARRA_YES") . "<input type=\"radio\" name=\"same_user_option_radio_email\" value=\"0\" checked> ";
			     $allSettings .=      JText::_("ARRA_NO") . "<input type=\"radio\" name=\"same_user_option_radio_email\" value=\"1\" > ";
			}
			else{
			     $allSettings .=      JText::_("ARRA_YES") . "<input type=\"radio\" name=\"same_user_option_radio_email\" value=\"0\"> ";
			     $allSettings .=      JText::_("ARRA_NO") . "<input type=\"radio\" name=\"same_user_option_radio_email\" value=\"1\" checked> ";
			}
		}
		$allSettings .=         "</td>";
		$allSettings .=     "</tr>";
		 
		$allSettings .=     "<tr>";
		$allSettings .=         "<td class=\"td_settings_options\">";
		$allSettings .=        "<span class=\"editlinktip hasTip\" title=\"" . JText::_("ARRA_OVERWRITE_BLOCK_TO_EXISTING_USER")."::".JText::_("ARRA_TIP_OWRITE_BLOCK") ."\" >".
					                 JText::_("ARRA_OVERWRITE_BLOCK_TO_EXISTING_USER") .
						       "</span>";
		$allSettings .=         "</td>";
		$allSettings .=         "<td class=\"td_settings\">";
		if($settings_saved == false){
			$allSettings .=          JText::_("ARRA_YES") . "<input type=\"radio\" name=\"same_user_option_radio_block\" value=\"0\"> ";
			$allSettings .=          JText::_("ARRA_NO") . "<input type=\"radio\" name=\"same_user_option_radio_block\" value=\"1\" checked> ";
		}
		else{
		     if($this->checked("same_user_option_radio_block",$result)==0){
			     $allSettings .=     JText::_("ARRA_YES") . "<input type=\"radio\" name=\"same_user_option_radio_block\" value=\"0\" checked> ";
			     $allSettings .=     JText::_("ARRA_NO") . "<input type=\"radio\" name=\"same_user_option_radio_block\" value=\"1\"> ";
			 }
			 else{
			     $allSettings .=     JText::_("ARRA_YES") . "<input type=\"radio\" name=\"same_user_option_radio_block\" value=\"0\"> ";
			     $allSettings .=     JText::_("ARRA_NO") . "<input type=\"radio\" name=\"same_user_option_radio_block\" value=\"1\" checked> ";
			 }
		}
		$allSettings .=         "</td>";
		$allSettings .=     "</tr>";
		
		$additional_clumns = $this->get("AdditionalColumns");
		foreach($additional_clumns as $key=>$value){
			$allSettings .=     "<tr>";
			$allSettings .=         "<td class=\"td_settings_options\">";
			$allSettings .=        "<span class=\"editlinktip hasTip\" title=\"".JText::_("ARRA_OVERWRITE_ADDITIONAL_COLUMN")."::".JText::_("ARRA_TIP_OVERWRITE_ADDITIONAL_COLUMN")."\" >".
										JText::_("ARRA_OVERWRITE_ADDITIONAL_COLUMN")." - \"".$value."\"";
								   "</span>";
			$allSettings .=         "</td>";
			$allSettings .=         "<td class=\"td_settings\">";		
			$allSettings .=        	    JText::_("ARRA_YES") . "<input type=\"radio\" name=\"overwrite_".$value."\" value=\"0\" > ";
			$allSettings .=         	JText::_("ARRA_NO") . "<input type=\"radio\" name=\"overwrite_".$value."\" value=\"1\" checked> ";
			$allSettings .=         "</td>";
		}
		
		$allSettings .=     "<tr>";
		$allSettings .=         "<td class=\"td_settings_options\">";
		$allSettings .=        "<span class=\"editlinktip hasTip\" title=\"" . JText::_("ARRA_ENCRYPTED_PASSWORD")."::".JText::_("ARRA_TIP_ENCRYPT_PASS") ."\" >".
					                JText::_("ARRA_ENCRYPTED_PASSWORD")."<br/>".									
						       "</span>".
							   "<span><a  style=\"color:red;\" href=\"#\" onclick=\"javascript:hide_show('encripted_div'); return false;\">".JText::_("ARRA_ENCRYPTED_PASSWORD_2_HEADER")."</a></span>".
							   "<div id=\"encripted_div\" style=\"display:none; color:red;\">".JText::_("ARRA_ENCRYPTED_PASSWORD_2")."</div>";
		$allSettings .=         "</td>";
		$allSettings .=         "<td class=\"td_settings\" valign=\"top\">";
		if($settings_saved == false){
			$allSettings .=         JText::_("ARRA_YES") . "<input type=\"radio\" name=\"encripted_password_radio\" value=\"0\" checked> ";
			$allSettings .=         JText::_("ARRA_NO") . "<input type=\"radio\" name=\"encripted_password_radio\" value=\"1\"> ";
		}
		else{
		    if($this->checked("encripted_password_radio",$result)==0){
			     $allSettings .=    JText::_("ARRA_YES") . "<input type=\"radio\" name=\"encripted_password_radio\" value=\"0\" checked> ";
			     $allSettings .=    JText::_("ARRA_NO") . "<input type=\"radio\" name=\"encripted_password_radio\" value=\"1\"> ";
			}
			else{
			    $allSettings .=     JText::_("ARRA_YES") . "<input type=\"radio\" name=\"encripted_password_radio\" value=\"0\"> ";
			    $allSettings .=     JText::_("ARRA_NO") . "<input type=\"radio\" name=\"encripted_password_radio\" value=\"1\" checked> ";
			}
		}
		$allSettings .=         "</td>";
		$allSettings .=     "</tr>";		
		$allSettings .=     "<tr>";
		$allSettings .=         "<td class=\"td_settings_options\">";
		$allSettings .=        "<span class=\"editlinktip hasTip\" title=\"" . JText::_("ARRA_GENERATE_PASSWORD")."::".JText::_("ARRA_TIP_GENERATE_PASS") ."\" >".
					                JText::_("ARRA_GENERATE_PASSWORD")."<br/>".									
						       "</span>".
							    "<span><a  style=\"color:red;\" href=\"#\" onclick=\"javascript:hide_show('generate_div'); return false;\">".JText::_("ARRA_GENERATE_PASSWORD_2_HEADER")."</a></span>".
							   "<div id=\"generate_div\" style=\"display:none; color:red;\">".JText::_("ARRA_GENERATE_PASSWORD_2")."</div>";					   
		$allSettings .=         "</td>";
		$allSettings .=         "<td class=\"td_settings\" valign=\"top\">";
		if($settings_saved == false){
			$allSettings .=         JText::_("ARRA_YES") . "<input type=\"radio\" name=\"generate_password_radio\" value=\"0\" checked> ";
			$allSettings .=         JText::_("ARRA_NO") . "<input type=\"radio\" name=\"generate_password_radio\" value=\"1\"> ";
		}
		else{
		    if($this->checked("generate_password_radio",$result)==0){
			    $allSettings .=     JText::_("ARRA_YES") . "<input type=\"radio\" name=\"generate_password_radio\" value=\"0\" checked> ";
			    $allSettings .=     JText::_("ARRA_NO") . "<input type=\"radio\" name=\"generate_password_radio\" value=\"1\"> ";
			}
			else{
				$allSettings .=     JText::_("ARRA_YES") . "<input type=\"radio\" name=\"generate_password_radio\" value=\"0\"> ";
			    $allSettings .=     JText::_("ARRA_NO") . "<input type=\"radio\" name=\"generate_password_radio\" value=\"1\" checked> ";
 			}
		}
		$allSettings .=         "</td>";
		$allSettings .=     "</tr>";		
		$allSettings .=     "<tr>";
		$allSettings .=         "<td class=\"td_settings_options\">";
		$allSettings .=        "<span class=\"editlinktip hasTip\" title=\"" . JText::_("ARRA_DEFAULT_PASSWORD")."::".JText::_("ARRA_TIP_DEFAULT_PASS") ."\" >".
					                JText::_("ARRA_DEFAULT_PASSWORD") .
						       "</span>";
		$allSettings .=         "</td>";
		$allSettings .=         "<td class=\"td_settings\">";
		$allSettings .=             "<input type=\"text\" name=\"default_password\" size=\"30px\">";
		$allSettings .=         "</td>";
		$allSettings .=     "</tr>";		
		$allSettings .= $this->setDefaultUsertype();				
		$allSettings .= "</table>";
		
		return $allSettings;
	}
	
	function checked($radio_name, $result){
	    $rows = explode(";", $result);
		foreach($rows as $key=>$value){
		     $value=explode("=", $value);
			 if($radio_name == trim($value[0])){
			     return trim($value[1]);
			 }
		} 
	}
	
	function setDefaultUsertype(){
	    JHTML::_('behavior.combobox');
		$all_user_type = $this->get('UserType');
	
	    $encripted  = "";	
		$encripted .=   "<tr>";
		$encripted .=   	"<td class=\"td_settings_options\">";
		$encripted .=       	"<span class=\"editlinktip hasTip\" title=\"" . JText::_("ARRA_DEFAULT_USERTYPE")."::".JText::_("ARRA_TIP_USERTYPE") ."\" >". JText::_("ARRA_DEFAULT_USERTYPE") .
						    	"</span>";
		$encripted .=       "</td>";
		$encripted .=       "<td  class=\"td_settings\">";
		if(isset($all_user_type) && is_array($all_user_type) && count($all_user_type)!=0){
		    $encripted .=  		"<input type=\"text\" value=\"".$all_user_type[0]['name']."\" name=\"position\" class=\"combobox\" id=\"position\" style=\"position: absolute; top: 705px !important; left: 1005px !important; width: 58px; z-index: 1000; height: 12px;\">";
			$encripted .=  		"<ul style=\"display: none;\" id=\"combobox-position\">";
			foreach($all_user_type as $key=>$value){
				 $encripted .= "<li>" .  $value['name'] . "</li>";
			}
		}
		else{
			$encripted .=  "<input type=\"text\" name=\"position\" class=\"combobox\" id=\"position\" style=\"position: absolute; top: 705px; left: 1005px; width: 58px; z-index: 1000; height: 12px;\">";	
		}
		$encripted .=      "</td>";
		$encripted .=  "</tr>";
		
		return $encripted;
	}
	
	function getFields(){
		$return = '<select name="fields" id="fields">';
		$fields = $this->get("Fields");
		$return .= '<option value="0">'.JText::_("ARRA_SELECT_ORDER").'</option>';
		
		if(isset($fields) && count($fields) > 0){
			foreach($fields as $key=>$field){
				$return .= '<option value="'.$field.'">'.$field.'</option>';
			}
		}
		$return .= '</select>';
		return $return;
	}
}

?>